;Sierpinski Triangle
;By: Dan Englender
;Feel free to use any of this code, but please give me credit
; -------- Includes ----------
#include		"ti83plus.inc"
#include        "mirage.inc"
; ----------------------------

#define data savesscreen



  .org    $9d93
  .db     $BB,$6D



  ret
  .db	1
icon:
	.db	0,0
	.db	%01101001,%00110000
	.db	%01001010,%10101000
	.db	%00101011,%00110000
	.db	%01101001,%10101000
	.db	0,0
	.db	%00000011,%11100100
	.db	%00001001,%01010100
	.db	%00011101,%01100100
	.db	%00010101,%01010100
	.db	%00111110,0
	.db	%00111110,0
	.db	%01101011,0
	.db	%01111111,0
	.db	0,0
desc:
        .db     "Sierpinki Triangle",0


init:
	ld	de,30*256+30
mloop:	ld	b,3
	call	irandom
	dec	a
	jr	z,dispp
	ld	l,60
	dec	a
	jr	nz,mc3

mc2:	ld	a,e
	add	a,l		; (e+60)/2
	ld	e,a		; (d+30)/2
	ld	l,30

mc3:	ld	a,d		; (d+60)/2
	add	a,l		; e/2
	ld	d,a
	
dispp:	sra	d
	sra	e
	push	de
	ld	a,e
	sub	62
	cpl
	ld	e,a
	ld	a,d
	add	a,17
	call	setpixel
	call	fastcopys
overhere:
	pop	de
	bcall(_getcsc)
	cp	$f
	jr	nz,mloop
	ret





.end

